//#define BREAK asm("int3")
#define BREAK asm("int3")
#define warn_(format, eol, args...) do { fprintf(stdout, "%s: " format eol, __func__, ##args); } while (0)
#define warn(format, args...) warn_(format, "\n", ##args)
#define error(string, args...) do { warn(string, ##args); BREAK; } while (0)
#define assert(expr) do { if (!(expr)) error("Failed assertion \"%s\"\n", #expr); } while (0)

#define trace_on(args) args
#define trace_off(args)
